/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_MESH_BASESFVERTEX_H
#define X3DTK_MESH_BASESFVERTEX_H

#include "Platform.h"

namespace X3DTK {
namespace MESH {

/*! \brief Base class declared in <b><X3DTK/MESH/scenegraph.h></b> 
 *  providing a vertex structure for the Mesh class.
 *
 * \ingroup MeshSceneGraph
 */

class BaseSFVertex
{
public:
  /// Gets the index.
  inline unsigned int getIndex() const {return _index;};

protected:
  /// Constructor.
  BaseSFVertex(unsigned int i);
  /// Destructor.
  virtual ~BaseSFVertex() = 0;
  
private:
  const unsigned int _index;
};

}
}

#endif
