/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_X3D_GLBUILDERSHAPEVISITOR_H
#define X3DTK_X3D_GLBUILDERSHAPEVISITOR_H

#include "X3D_ShapeVisitor.h"
#include "X3D_GLBuilderStateVariables.h"

namespace X3DTK {
namespace X3D {

class Appearance;
class FillProperties;
class LineProperties;
class Material;
class Shape;

/*! \brief Class declared in <b><X3DTK/X3D/glbuilder.h></b> providing a visitor
 *  of the Shape component for the X3D::GLBuilder processor.
 *
 *  \ingroup X3D
 */

class GLBuilderShapeVisitor : public ShapeVisitor
{
public:
  /// Constructor.
  GLBuilderShapeVisitor();

  /// Enters a Appearance.
  static void enterAppearance(Appearance *A);
  /// Enters a FillProperties.
  static void enterFillProperties(FillProperties *F);
  /// Enters a LineProperties.
  static void enterLineProperties(LineProperties *L);
  /// Enters a Material.
  static void enterMaterial(Material *M);
  /// Enters a Shape.
  static void enterShape(Shape *S);
};

}
}

#endif
