/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_LIBXMLFILEELEMENT_H
#define X3DTK_LIBXMLFILEELEMENT_H

#include "X3DFileElement.h"

typedef unsigned char xmlChar;

namespace X3DTK {

class libXMLFileElementImplementation;

namespace X3D {
  struct _X3DParseState;
  typedef _X3DParseState X3DParseState;
}

/*! \brief Class declared in <b><X3DTK/kernel.h></b> providing an implementation
 *  of X3DFileElement for the libXML2 library.
 *
 *  \ingroup X3DLoader
 */

class libXMLFileElement : public X3DFileElement
{
public:
  /// Constructor.
  libXMLFileElement(const SFString &name, const void *const attributes);
  /// Destructor.
  ~libXMLFileElement();  
  /// Gets the name.
  SFString getName() const;
  /// Gets the attribute at the index i.
  SFString getAttribute(int i) const;
  /// Gets the index of the attribute. Returns -1 if doesn't exist.
  int getIndexAttribute(const SFString &attribute) const;
  
private:
  libXMLFileElementImplementation *impl;
};

}

#endif
